/* xsoldier, a shoot 'em up game with "not shooting" bonus
 * Copyright (C) 1997 Yuusuke HASHIMOTO <s945750@educ.info.kanagawa-u.ac.jp>
 * Copyright (C) 2002 Oohara Yuuma  <oohara@libra.interq.or.jp>
 *
 * This is a copyleft program.  See the file LICENSE for details.
 */
/* $Id: ending.c,v 1.2 2002/04/11 23:44:50 oohara Exp $ */

/* JSTK is defined in config.h */
#include <config.h>
/* pause */
#include <unistd.h>

#include <stdio.h>
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>

#include "image.h"
#include "xsoldier.h"
#include "extern.h"
#include "key.h"
#include "star.h"

#ifdef JSTK
#include "joystick.h"
#endif

#include "ending.h"

void Ending(void)
{
    char stuff[][2][32] = 
    {
    {"XSoldier stuff",      ""},
    {"Producer",            "Y.Hashimoto"},
    {"Program",             "R.Masuda"},
    {"",                    "Y.Hashimoto"},
    {"Character Algorithm", "K.Inomata"},
    {"",                    "H.Yokobori"},
    {"",                    "M.Nakayama"},
    {"",                    "Y.Hashimoto"},
    {"Character Design",    "H.Hayakawa"},
    {"",                    "Y.Hashimoto"},
    {"Special Thanks",      "N.Oohashi"},
    {"",                    "T.Yamada"},
    {"",                    "T.Igari"},
    {"",                    "RAKI all members"},
    {"",                    ".... and YOU."},
    };

    char msg[][32] = 
    {
	"Try Next Stage!!",
	"You are a great soldier!!!",
	"crazy ........"
    };

    /* number of staffs */
    int stfnumber = 15;
    int count = 0;
    int time = (stfnumber + 6) * 100;
    int len;
    int i;

    while (1)
    {
        if (waittime && (signal_delivered==0))
	    pause();
        signal_delivered = 0;

	if (count < time)
        {
          if (manage->Loop < 3)
            count += 4;
          else
            count++;
        }
        
	while(XPending(dpy))
	{
	    XNextEvent(dpy,&event);
	    switch(event.type)
	    {
	      case EnterNotify:
		XAutoRepeatOff(dpy);
		break;
	      case LeaveNotify:
		XAutoRepeatOn(dpy);
		break;
	      case KeyPress:
                if (XLookupKeysym(&(event.xkey),0) == XK_space)
                {
		    if (count >= time)
			return;
		}
	    }
	}
	
#ifdef JSTK
	readJS();
	if ((joymask&Shot) || (joymask&SpeedUP))	
	{
	    if (count >= time)
		return;
	}
#endif

	XFillRectangle(dpy,WorkPixmap,BackGC,0,0,FieldW,FieldH);
	DrawStar(StarPtn1);
	DrawStar(StarPtn2);

	for (i=0; i<stfnumber; i++)
	{
	    if (i == 0)
	    {
		XDrawString(dpy,WorkPixmap,FontGC,210,FieldH - count + 100*i,stuff[i][0],strlen(stuff[i][0]));
		XDrawString(dpy,WorkPixmap,FontGC,450,FieldH - count + 100*i,stuff[i][1],strlen(stuff[i][1]));
	    }
	    else
	    {
		XDrawString(dpy,WorkPixmap,FontGC,100,FieldH - count + 100*i,stuff[i][0],strlen(stuff[i][0]));
		XDrawString(dpy,WorkPixmap,FontGC,300,FieldH - count + 100*i + 30,stuff[i][1],strlen(stuff[i][1]));
	    }
	}
	
	if (count > time-30)
	{
	    len = count - (time-30);

	    if (manage->Loop < 3)
	    {
		if (len > strlen(msg[manage->Loop-1]))
		    len = strlen(msg[manage->Loop-1]);
		XDrawString(dpy,WorkPixmap,FontGC,200,400,msg[manage->Loop-1],len);
	    }
	    else
	    {
		if (len > strlen(msg[2]))
		    len = strlen(msg[2]);
		XDrawString(dpy,WorkPixmap,FontGC,200,400,msg[2],len);
	    }
	}

	XCopyArea(dpy,WorkPixmap,win,BackGC,0,0,FieldW,FieldH,0,0);

	XFlush(dpy);
	XSync(dpy,False);
    }
}
